# SPDX-FileCopyrightText: 2020 Mintlab B.V.
#
# SPDX-License-Identifier: EUPL-1.2

# AUTOGENERATED FILE - No need to edit
# GENERATED AT: 2024-04-03T19:02:05"
# Re-create by running 'generate-routes' command
# Run 'generate-routes --help' for more options


import webtest
from unittest import TestCase, mock
from zsnl_case_management_http import main, views


class TestRoutes_apidocs(TestCase):
    def setUp(self):
        self.patched_apidocs = mock.patch(
            "zsnl_case_management_http.views.apidocs", spec=views.apidocs
        )
        self.apidocs = self.patched_apidocs.start()

        settings = {
            "minty_service.infrastructure.config_file": "tests/data/config.conf"
        }
        app = main({}, **settings)
        self.mock_app = webtest.TestApp(app)

    def tearDown(self):
        self.patched_apidocs.stop()

    def test_routes_apidocs(self):
        self.apidocs.apidocs_fileserver.return_value = 200
        self.mock_app.get("/api/v2/cm/openapi/{filename}", status=200)


class TestRoutes_authorization(TestCase):
    def setUp(self):
        self.patched_authorization = mock.patch(
            "zsnl_case_management_http.views.authorization",
            spec=views.authorization,
        )
        self.authorization = self.patched_authorization.start()

        settings = {
            "minty_service.infrastructure.config_file": "tests/data/config.conf"
        }
        app = main({}, **settings)
        self.mock_app = webtest.TestApp(app)

    def tearDown(self):
        self.patched_authorization.stop()


class TestRoutes_case(TestCase):
    def setUp(self):
        self.patched_case = mock.patch(
            "zsnl_case_management_http.views.case", spec=views.case
        )
        self.case = self.patched_case.start()

        settings = {
            "minty_service.infrastructure.config_file": "tests/data/config.conf"
        }
        app = main({}, **settings)
        self.mock_app = webtest.TestApp(app)

    def tearDown(self):
        self.patched_case.stop()


class TestRoutes_case_management(TestCase):
    def setUp(self):
        self.patched_case_management = mock.patch(
            "zsnl_case_management_http.views.case_management",
            spec=views.case_management,
        )
        self.case_management = self.patched_case_management.start()

        settings = {
            "minty_service.infrastructure.config_file": "tests/data/config.conf"
        }
        app = main({}, **settings)
        self.mock_app = webtest.TestApp(app)

    def tearDown(self):
        self.patched_case_management.stop()

    def test_routes_case_management(self):
        self.case_management.create_case_relation.return_value = 200
        self.mock_app.post("/api/v2/cm/case/create_case_relation", status=200)
        self.case_management.get_case_type_version.return_value = 200
        self.mock_app.get(
            "/api/v2/cm/case_type/get_case_type_version", status=200
        )
        self.case_management.get_case_type_active_version.return_value = 200
        self.mock_app.get(
            "/api/v2/cm/case_type/get_active_version", status=200
        )
        self.case_management.set_subject_related_custom_object.return_value = (
            200
        )
        self.mock_app.post(
            "/api/v2/cm/subject/set_related_custom_object", status=200
        )
        self.case_management.get_subject.return_value = 200
        self.mock_app.get("/api/v2/cm/subject/get_subject", status=200)
        self.case_management.get_subject_relations.return_value = 200
        self.mock_app.get("/api/v2/cm/case/get_subject_relations", status=200)
        self.case_management.create_subject_relation.return_value = 200
        self.mock_app.post(
            "/api/v2/cm/case/create_subject_relation", status=200
        )
        self.case_management.get_case_relations.return_value = 200
        self.mock_app.get("/api/v2/cm/case/get_case_relations", status=200)
        self.case_management.update_subject_relation.return_value = 200
        self.mock_app.post(
            "/api/v2/cm/case/update_subject_relation", status=200
        )
        self.case_management.delete_subject_relation.return_value = 200
        self.mock_app.post(
            "/api/v2/cm/case/delete_subject_relation", status=200
        )
        self.case_management.reorder_case_relation.return_value = 200
        self.mock_app.post("/api/v2/cm/case/reorder_case_relation", status=200)
        self.case_management.delete_case_relation.return_value = 200
        self.mock_app.post("/api/v2/cm/case/delete_case_relation", status=200)


class TestRoutes_subject(TestCase):
    def setUp(self):
        self.patched_subject = mock.patch(
            "zsnl_case_management_http.views.subject", spec=views.subject
        )
        self.subject = self.patched_subject.start()

        settings = {
            "minty_service.infrastructure.config_file": "tests/data/config.conf"
        }
        app = main({}, **settings)
        self.mock_app = webtest.TestApp(app)

    def tearDown(self):
        self.patched_subject.stop()


class TestRoutes_tasks(TestCase):
    def setUp(self):
        self.patched_tasks = mock.patch(
            "zsnl_case_management_http.views.tasks", spec=views.tasks
        )
        self.tasks = self.patched_tasks.start()

        settings = {
            "minty_service.infrastructure.config_file": "tests/data/config.conf"
        }
        app = main({}, **settings)
        self.mock_app = webtest.TestApp(app)

    def tearDown(self):
        self.patched_tasks.stop()

    def test_routes_tasks(self):
        self.tasks.get_task_list.return_value = 200
        self.mock_app.get("/api/v2/cm/task/get_task_list", status=200)
        self.tasks.create_task.return_value = 200
        self.mock_app.post("/api/v2/cm/task/create", status=200)
        self.tasks.delete_task.return_value = 200
        self.mock_app.post("/api/v2/cm/task/delete", status=200)
        self.tasks.update_task.return_value = 200
        self.mock_app.post("/api/v2/cm/task/update", status=200)
        self.tasks.set_task_completion.return_value = 200
        self.mock_app.post("/api/v2/cm/task/set_completion", status=200)


class TestRoutes_custom_object_type(TestCase):
    def setUp(self):
        self.patched_custom_object_type = mock.patch(
            "zsnl_case_management_http.views.custom_object_type",
            spec=views.custom_object_type,
        )
        self.custom_object_type = self.patched_custom_object_type.start()

        settings = {
            "minty_service.infrastructure.config_file": "tests/data/config.conf"
        }
        app = main({}, **settings)
        self.mock_app = webtest.TestApp(app)

    def tearDown(self):
        self.patched_custom_object_type.stop()


class TestRoutes_custom_object(TestCase):
    def setUp(self):
        self.patched_custom_object = mock.patch(
            "zsnl_case_management_http.views.custom_object",
            spec=views.custom_object,
        )
        self.custom_object = self.patched_custom_object.start()

        settings = {
            "minty_service.infrastructure.config_file": "tests/data/config.conf"
        }
        app = main({}, **settings)
        self.mock_app = webtest.TestApp(app)

    def tearDown(self):
        self.patched_custom_object.stop()


class TestRoutes_search_result(TestCase):
    def setUp(self):
        self.patched_search_result = mock.patch(
            "zsnl_case_management_http.views.search_result",
            spec=views.search_result,
        )
        self.search_result = self.patched_search_result.start()

        settings = {
            "minty_service.infrastructure.config_file": "tests/data/config.conf"
        }
        app = main({}, **settings)
        self.mock_app = webtest.TestApp(app)

    def tearDown(self):
        self.patched_search_result.stop()


class TestRoutes_contact(TestCase):
    def setUp(self):
        self.patched_contact = mock.patch(
            "zsnl_case_management_http.views.contact", spec=views.contact
        )
        self.contact = self.patched_contact.start()

        settings = {
            "minty_service.infrastructure.config_file": "tests/data/config.conf"
        }
        app = main({}, **settings)
        self.mock_app = webtest.TestApp(app)

    def tearDown(self):
        self.patched_contact.stop()


class TestRoutes_export_file(TestCase):
    def setUp(self):
        self.patched_export_file = mock.patch(
            "zsnl_case_management_http.views.export_file",
            spec=views.export_file,
        )
        self.export_file = self.patched_export_file.start()

        settings = {
            "minty_service.infrastructure.config_file": "tests/data/config.conf"
        }
        app = main({}, **settings)
        self.mock_app = webtest.TestApp(app)

    def tearDown(self):
        self.patched_export_file.stop()
